/* Anders Ellefsrud 3/11-87 (anders@ifi.uio.no) */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/file.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#if defined(sgi) || (defined(__SVR4) && defined(sun))
# define USE_UTMPX
# include <utmpx.h>
# define struct_utmp struct utmpx *
# define REAL_UTMP_FILE UTMPX_FILE
#else
# include <utmp.h>
# define struct_utmp struct utmp
# ifndef UTMP_FILE
#  define REAL_UTMP_FILE "/etc/utmp"
# else
#  define REAL_UTMP_FILE UTMP_FILE
# endif
#endif
#ifdef sgi
#include <sys/param.h>	/* MAXHOSTNAMELEN */
#endif

	
#ifdef linux
#  ifndef MAXHOSTNAMELEN
#    define MAXHOSTNAMELEN 64
#  endif
#endif


#ifndef lint
char *rcsid = "$Id: rhost.c,v 1.16 2000/01/17 22:57:11 kjetilho Exp $";
#endif

main()
{
	struct_utmp     ustat;
	int             jfn;
	char           *p, *x;
	char           *getenv();
	struct in_addr	addr;
	struct hostent *hent;

	p = getenv ("SSH2_CLIENT");
	if (p == 0) {
		p = getenv ("SSH_CLIENT");
		if (p && (x = strchr (p, ' ')))
			*x = '\0';
	}
	if (p == 0)
		p = getenv("DISPLAY");
	if (p == 0 || *p == 0 || *p == ':') {
		char *tty, *s;

		if ((tty = ttyname (0)) == NULL)
			goto utmp_done;	/* no tty associated with stdin */

		if (!strncmp (tty, "/dev/", 5))
			tty += 5;
#ifdef USE_UTMPX
		while (ustat = getutxent ()) {
			if (ustat->ut_type != USER_PROCESS)
				continue;
			if (!strncmp (ustat->ut_line, tty,
				      sizeof (ustat->ut_line))) {
				p = ustat->ut_host;
				p[sizeof (ustat->ut_host)] = '\0';
				break;
			}
		}
#else
		if ((jfn = open(REAL_UTMP_FILE, 0)) == -1)
			exit(1);
		while (read(jfn, &ustat, sizeof (ustat)) == sizeof (ustat)) {
			if (!strncmp (ustat.ut_line, tty, sizeof (ustat.ut_line))) {
				p = ustat.ut_host;
				p[sizeof ustat.ut_host] = '\0';	/* Null terminate ut_host */
				break;
			}
		}
		close(jfn);
#endif /* ! USE_UTMPX */
	}
utmp_done:
	if (p == 0 || *p == 0 || *p == ':') {
		p = malloc (MAXHOSTNAMELEN);
		if (gethostname (p, MAXHOSTNAMELEN) == -1) {
			perror ("gethostname");
			exit (0);
		}
	}
	if (x = strchr( p, ':'))
		*x = '\0';
	if ((addr.s_addr = inet_addr(p)) != (unsigned long) -1 &&
	    (hent = gethostbyaddr((char *) &addr.s_addr, sizeof(addr), AF_INET))) {
		p = hent->h_name;
	}
	printf("%s\n", p);
	return 0;
}



